"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var dom_1 = require("../../utils/dom");
var index_1 = require("../AbstractWhiteboard/index");
var prefix = 'fcw-board';
var MirrorWhiteboard = (function (_super) {
    __extends(MirrorWhiteboard, _super);
    function MirrorWhiteboard() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mode = 'mirror';
        return _this;
    }
    MirrorWhiteboard.prototype.init = function () {
        var _this = this;
        this.imgsContainer = dom_1.createDivWithClassName(prefix + "-imgs", this.target);
        this.pagesContainer = dom_1.createDivWithClassName(prefix + "-pages", this.target);
        if (!this.eventHub) {
            throw new Error('Invalid eventHub');
        }
        this.eventHub.on('sync', function (ev) {
            if (ev.target !== 'whiteboard' || !ev.border) {
                return;
            }
            if (ev.event === 'borderSnap') {
                _this.applySnap(ev.border);
            }
            if (ev.event === 'borderChangePage' && ev.id === _this.id) {
                if (_this.isInitialized) {
                    _this.onPageChange(ev.border.visiblePageIndex);
                }
            }
            if (ev.event === 'finish' && ev.id === _this.id) {
                _this.destroy();
            }
        });
    };
    MirrorWhiteboard.prototype.destroy = function () {
        _super.prototype.destroy.call(this);
    };
    MirrorWhiteboard.prototype.onPageChange = function (nextPageIndex) {
        if (this.visiblePageIndex === nextPageIndex) {
            return;
        }
        this.siema.goTo(nextPageIndex);
        this.visiblePageIndex = nextPageIndex;
        this.pages.forEach(function (page, i) {
            if (nextPageIndex === i) {
                page.show();
            }
            else {
                page.hide();
            }
        });
        this.emit({
            event: 'borderChangePage',
            id: this.id,
            target: 'whiteboard',
            border: this.captureSnap()
        });
    };
    return MirrorWhiteboard;
}(index_1.AbstractWhiteboard));
exports.MirrorWhiteboard = MirrorWhiteboard;
