import { HotkeysListener } from 'fc-hotkeys';
import { Source } from './../../utils/types';
import { Baseboard } from './../Baseboard/index';
import { BaseMarker } from './../../markers/BaseMarker/index';
import { WhitePage } from '../../whiteboard/WhitePage';
import { onSyncFunc } from '../../event/SyncEvent';
import { Toolbar } from '../../toolbar/Toolbar';
import { ToolbarItem } from '../../toolbar/ToolbarItem';
import './index.less';
export declare class Drawboard extends Baseboard {
    mountContainer: HTMLElement;
    scale: number;
    zIndex: number;
    allowKeyboard?: boolean | undefined;
    page: WhitePage;
    listener: HotkeysListener;
    markers: BaseMarker[];
    readonly markerMap: {
        [key: string]: BaseMarker;
    };
    activeMarker: BaseMarker | null;
    toolbarItems: ToolbarItem[];
    toolbar: Toolbar;
    toolbarUI: HTMLElement;
    onComplete: (dataUrl: string) => void;
    onChange: onSyncFunc;
    onCancel: () => void;
    constructor(source: Source, { allowKeyboard, extraToolbarItems, mountContainer, page, zIndex, onChange }?: Partial<Drawboard> & {
        extraToolbarItems?: ToolbarItem[];
    });
    open: (onComplete?: ((dataUrl: string) => void) | undefined, onCancel?: (() => void) | undefined) => void;
    hide: () => void;
    show: () => void;
    destroy: () => void;
    render: (onComplete: (dataUrl: string) => void, onCancel?: (() => void) | undefined) => void;
    addMarker: (markerType: typeof BaseMarker, { id, originX, originY }?: {
        id?: string | undefined;
        originX?: number | undefined;
        originY?: number | undefined;
    }) => BaseMarker;
    deleteActiveMarker: () => void;
    clearMarkers: () => void;
    deleteMarkerWithEvent: (marker: BaseMarker | null) => void;
    private setTargetRect;
    private startRender;
    private attachEvents;
    private mouseDown;
    private mouseMove;
    private mouseUp;
    private onKeyboard;
    private adjustUI;
    private adjustSize;
    private positionUI;
    private positionToolbar;
    private showUI;
    private setStyles;
    private toolbarClick;
    private selectMarker;
    deleteMarker: (marker: BaseMarker) => void;
    private complete;
    private cancel;
    private renderFinished;
    private renderFinishedClose;
}
