import { BorderEventType } from './border-events';
import { MarkerEventType, MarkerData } from './marker-events';
import { WhiteboardSnap } from '../whiteboard/AbstractWhiteboard/snap';
export declare type TargetType = 'whiteboard' | 'page' | 'marker';
export declare type EventType = MarkerEventType | BorderEventType;
export declare type onSyncFunc = (ev: SyncEvent) => void;
export interface SyncEvent {
    target: TargetType;
    id?: string;
    parentId?: string;
    event: EventType;
    marker?: MarkerData;
    border?: WhiteboardSnap;
    timestamp?: number;
}
