import { ToolbarButton } from './ToolbarButton';
import { ToolbarItem } from './ToolbarItem';
import './index.less';
import { DomEventAware } from '../renderer/DomEventAware/index';
import { Drawboard } from '../drawboard/Drawboard/index';
export declare type MouseHandler = (ev: MouseEvent) => void;
export declare class Toolbar extends DomEventAware {
    id: string;
    zIndex: number;
    toolbarItems: ToolbarItem[];
    toolbarUI: HTMLElement;
    toolbarButtons: ToolbarButton[];
    readonly toolbarButtonMap: Record<string, ToolbarButton>;
    clickHandler: (ev: MouseEvent, toolbarItem: ToolbarItem) => void;
    constructor(toolbarItems: ToolbarItem[], clickHandler: (ev: MouseEvent, toolbarItem: ToolbarItem) => void);
    getUI: (drawboard: Drawboard) => HTMLElement;
    hide(): void;
    show(): void;
    protected onMouseDown: (downEv: MouseEvent) => void;
    protected onMouseUp: (ev: MouseEvent) => void;
    protected onMouseMove: (ev: MouseEvent) => void;
    protected onDragMove: (event: any) => void;
}
