import { Source, Mode } from './../../utils/types';
import { Drawboard } from './../../drawboard/Drawboard/index';
import { WhitepageSnap } from '../AbstractWhiteboard/snap';
import { AbstractWhiteboard } from '../AbstractWhiteboard/index';
import './index.less';
import { ToolbarItem } from '../../toolbar/ToolbarItem';
export declare class WhitePage {
    id: string;
    source: Source;
    target: HTMLImageElement;
    container: HTMLDivElement;
    parentContainer?: HTMLDivElement;
    mode: Mode;
    drawboard: Drawboard;
    whiteboard?: AbstractWhiteboard;
    constructor(source: Source, { mode, whiteboard, parentContainer, extraToolbarItems }?: Partial<WhitePage> & {
        extraToolbarItems?: ToolbarItem[];
    });
    open(): void;
    hide(): void;
    show(): void;
    destroy(): void;
    captureSnap(): WhitepageSnap;
    applySnap(snap: WhitepageSnap): void;
    private initSource;
    protected initMaster(extraToolbarItems?: ToolbarItem[]): void;
    protected initMirror(): void;
    private onPageSync;
    private onMarkerSync;
}
